/**************/
/* laskurh3.c */
/****************************************************************************/
/*
** Ohjelma, jolla voidaan laskea autojen lukumri.
**
**
** Toimii sellaisenaan jos kirjasto napapula3 osataan tehd ko.
** koneelle.
**
** Nytt muutettu graafisemman nkiseksi ja nytn osien
** hallintaa on parannettu.
** Nppimet ja laskurit ovat taulukoissa, jotka loppuvat loppu
** nppimeen ja laskuriin (tunnus, yleens 0).
** Nppimet siirretty omaksi kirjastokseen, johon
** toteutettu DOS-versio ja Windows-versio
**
** Ohjelman kntmiseksi tarvitaan projekti, jossa on
**   LASKUR3H.C
**   NAPPULA3.C
**   HIIRU.C      (DOS)
**   LASKURI.DEF  (Windows)
**
** Vesa Lappalainen
** 11.8.1992
**
** Tehtvi: 1) Lis ohjelmaan polkupyrien laskeminen.
**              Moneenko kohtaan tulee muutos?
**           2) Muuta ohjelmaa siten, ett mys laskurin nytn painaminen
**              lis laskurin arvoa.  Montako muutosta?
**           3) Lis ohjelmaan HELP-nppin, joka kertoo tietoja ohjelmasta
**              Helpist pois painamalla ESC!
**
**
*/
/****************************************************************************/

#include <stdlib.h>
#include "nappula3.h"

/****************************************************************************/
/* Globaalit nppimet:                                                     */

typedef enum {              /* Tunnetut komennot:                           */
  TYHJA,                           /* Lopun tunniste                        */
  POISTU,
  NOLLAA,
  LISAA
} komento_tyyppi;

typedef enum {              /* Kytetyt laskurityypit ja niiden tunnisteet  */
  TYHJA_LASKURI,                   /* Lopun tunniste                        */
  HENKILOAUTOJA,
  KUORMA_AUTOJA
} laskuri_tunniste_tyyppi;

static nappain_tyyppi nappaimet[] = {
  /*                        x  y   lev kork                                 */
  { 'X',"eXit"          ,{{ 2, 2},{ 0, 0}}, POISTU , 0             },
  { 'N',"Nollaa"        ,{{30,13},{ 0, 0}}, NOLLAA , 0             },
  { 'H',"Henkilautoja" ,{{13, 5},{ 0, 0}}, LISAA  , HENKILOAUTOJA },
  { 'K',"Kuorma-autoja" ,{{38, 5},{ 0, 0}}, LISAA  , KUORMA_AUTOJA },
  {  0 ,NULL            ,{{ 0, 0},{ 0, 0}}, TYHJA  , 0             }
};


/****************************************************************************/
/* Globaalit laskurit:                                                      */
static laskuri_tyyppi laskurit[] = {
  /*                             x  y   lev kork                            */
  { HENKILOAUTOJA, 0 , "%19ld ",{{10, 8},{20, 1}} },
  { KUORMA_AUTOJA, 0 , "%19ld ",{{35, 8},{20, 1}} },
  { TYHJA_LASKURI, 0 , NULL    ,{{ 0, 0},{ 0, 0}} }
};


/****************************************************************************/
void piirra_naytto(nappain_tyyppi *nappaimet,laskuri_tyyppi *laskurit)
{
  int i;


  tyhjenna_ruutu();

  for (i=0; nappaimet[i].valinta_kirjain; i++)
    piirra_nappula(&nappaimet[i]);

  for (i=0; laskurit[i].tunnus; i++)
    piirra_laskuri(&laskurit[i]);

}


/****************************************************************************/
int laske(nappain_tyyppi *nappaimet,laskuri_tyyppi *laskurit)
{
  komento_tyyppi komento;
  int            lisa_viesti;

  while (1) {
    komento = lue_komento(nappaimet,laskurit,&lisa_viesti);
    switch (komento) {
      case LISAA  : lisaa_laskuria(laskurit,lisa_viesti); break;
      case NOLLAA : nollaa_laskurit(laskurit); break;
      case PIIRRA : piirra_naytto(nappaimet,laskurit); break;
      case SYS_EXIT:
      case POISTU : return 0;
    }
  }

}


/****************************************************************************/
int laskin_main(void)
{
  alusta_nappulat(nappaimet);
  piirra_naytto(nappaimet,laskurit);
  laske(nappaimet,laskurit);
  return 0;
}